#pragma once

// Base Class
#include "../Filter.h"

#include <chrono>

namespace armarx::armem::server::ltm::processor::filter
{

enum ImportanceType{
    CONFIDENCE,
    ACCESSES
};

class SnapshotImportanceFilter : public SnapshotFilter
{
public:

    static const constexpr char* NAME = "SnapshotImportanceFilter";
    static const constexpr char* PARAM_THRESHOLD = "Threshold";
    static const constexpr char* PARAM_TYPE = "Type";

    SnapshotImportanceFilter() = default;

    virtual bool accept(const armem::wm::EntitySnapshot& e) override;
    void configure(const nlohmann::json& json) override;

    FilterStatistics getFilterStatistics() override;
    std::string getName() override;

private:
    double threshold = 1.0;
    FilterStatistics stats;
    ImportanceType type;

    bool important(armem::wm::EntityInstance& i);

};

}
