/*
 * This file is part of ArmarX.
 *
 * ArmarX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * ArmarX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * @author     Joana Plewnia ( uhfpm at student dot kit dot edu )
 * @date       2023
 * @copyright  http://www.gnu.org/licenses/gpl-2.0.txt
 *             GNU General Public License
 */

#pragma once

#include <algorithm>
#include <map>
#include <vector>

#include <RobotAPI/libraries/aron/core/data/variant/All.h>
#include <RobotAPI/libraries/armem/server/ltm/processors/filter/Filter.h>

namespace armarx::armem::server::test
{
    void save_statistics(
            std::map<std::string, std::map<std::string, ltm::processor::SnapshotFilter::FilterStatistics>> stats,
            std::map<std::string, armarx::core::time::DateTime> time_stats,
            armarx::core::time::DateTime firstStartedRecording,
            armarx::core::time::DateTime firstStoppedRecording,
            std::filesystem::path exportPath = "/tmp",
            std::string exportName ="MemoryExports",
            std::string memoryName = "",
            std::string sim_json_data = "",
            std::string object_memory_json_data = ""
            );

    nlohmann::json load_scene_information(std::string om_or_sim);

    nlohmann::json find_difference(nlohmann::json om, nlohmann::json sim);

    std::filesystem::path getStatisticsDirectory(
            std::filesystem::path exportPath = "/tmp",
            std::string exportName ="MemoryExports",
            std::string memoryName = "NoMemoryName");

    nlohmann::json filter_statistics_comparison();

    void filter_statistics(
            std::map<std::string, ltm::processor::SnapshotFilter::FilterStatistics> statistics_processors,
            std::string memoryName,
            armarx::core::time::DateTime firstStartedRecording,
            armarx::core::time::DateTime firstStoppedRecording,
            nlohmann::json* statistics);

}
